/*
 *   mp3guessenc header
 *   Copyright (C) 2011-2012 Elio Blanca <eblanca76@users.sourceforge.net>
 *
 *	Xing VBR tagging for LAME.
 *	Copyright (c) 1999 A.L. Faber
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef MP3GUESSENC_H
#define MP3GUESSENC_H

int samples_tab[2][3] = {{ 384,1152,1152},
                         { 384,1152, 576}};

int samplerate_tab [3][4] = {{11025,99999,22050,44100},
                             {12000,99999,24000,48000},
                             { 8000,99999,16000,32000}};

static int bitrate_tab[2][3][16] = {
  { {128, 32, 64, 96,128,160,192,224,256,288,320,352,384,416,448,},
    {128, 32, 48, 56, 64, 80, 96,112,128,160,192,224,256,320,384,},
    {128, 32, 40, 48, 56, 64, 80, 96,112,128,160,192,224,256,320,} },

  { {128, 32, 48, 56, 64, 80, 96,112,128,144,160,176,192,224,256,},
    {128,  8, 16, 24, 32, 40, 48, 56, 64, 80, 96,112,128,144,160,},
    {128,  8, 16, 24, 32, 40, 48, 56, 64, 80, 96,112,128,144,160,} }
};

char sideinfo_tab[2][2] = {{32,17},{17,9}};

#define HEADER_FIELD_SYNC      0xFFE00000
#define HEADER_FIELD_MPEG_ID     0x180000
#define HEADER_FIELD_LSF          0x80000 /* this is not a *real* field, it is just a commodity for accessing lsf bit */
#define HEADER_FIELD_LAYER        0x60000
#define HEADER_FIELD_CRC          0x10000
#define HEADER_FIELD_BITRATE       0xF000
#define HEADER_FIELD_SAMPRATE       0xC00
#define HEADER_FIELD_PADDING        0x200
#define HEADER_FIELD_PRIVATE        0x100
#define HEADER_FIELD_CHANNELS        0xC0
#define HEADER_FIELD_MODEXT          0x30
#define HEADER_FIELD_COPYRIGHT        0x8
#define HEADER_FIELD_ORIGINAL         0x4
#define HEADER_FIELD_EMPHASIS         0x3

#define HEADER_CONSTANT_FIELDS_STRICT ( \
        HEADER_FIELD_SYNC |      \
        HEADER_FIELD_MPEG_ID |   \
        HEADER_FIELD_LAYER |     \
        HEADER_FIELD_CRC |       \
        HEADER_FIELD_SAMPRATE |  \
        HEADER_FIELD_CHANNELS |  \
        HEADER_FIELD_COPYRIGHT | \
        HEADER_FIELD_ORIGINAL)

#define HEADER_CONSTANT_FIELDS ( \
        HEADER_FIELD_SYNC |      \
        HEADER_FIELD_MPEG_ID |   \
        HEADER_FIELD_LAYER |     \
        HEADER_FIELD_CRC |       \
        HEADER_FIELD_SAMPRATE |  \
        HEADER_FIELD_COPYRIGHT | \
        HEADER_FIELD_ORIGINAL)

#define HEADER_ANY_BUT_BITRATE_AND_PADDING_FIELDS ( \
        HEADER_FIELD_SYNC |      \
        HEADER_FIELD_MPEG_ID |   \
        HEADER_FIELD_LAYER |     \
        HEADER_FIELD_CRC |       \
        HEADER_FIELD_SAMPRATE |  \
        HEADER_FIELD_PRIVATE |   \
        HEADER_FIELD_CHANNELS |  \
        HEADER_FIELD_MODEXT |    \
        HEADER_FIELD_COPYRIGHT | \
        HEADER_FIELD_ORIGINAL |  \
        HEADER_FIELD_EMPHASIS)

#define LAMETAGSIZE   36
#define LAME_STRING_LENGTH 50
#define BUFFER_SIZE 1120 // was 1024
#define SCAN_SIZE 65536  /* default is to scan 64 kB when searching for a valid frame */
#define RESYNC_POS_CURRENT -10 /* using resync_mp3(fp, &h, RESYNC_POS_CURRENT) makes it start its
                                * search from current position, instead of fseeking to `pos' */

typedef struct FILEBITS {
  FILE *fp;
  unsigned int lastBits;
  int nLastBits;
  int location;
  long bit_size; /* audio stream size in bit */
} FILEBITS;

int genre_last=147;
char *genre_list[]={
	"Blues", "Classic Rock", "Country", "Dance", "Disco", "Funk",
	"Grunge", "Hip-Hop", "Jazz", "Metal", "New Age", "Oldies",
	"Other", "Pop", "R&B", "Rap", "Reggae", "Rock",
	"Techno", "Industrial", "Alternative", "Ska", "Death Metal", "Pranks",
	"Soundtrack", "Euro-Techno", "Ambient", "Trip-Hop", "Vocal", "Jazz+Funk",
	"Fusion", "Trance", "Classical", "Instrumental", "Acid", "House",
	"Game", "Sound Clip", "Gospel", "Noise", "AlternRock", "Bass",
	"Soul", "Punk", "Space", "Meditative", "Instrumental Pop", "Instrumental Rock",
	"Ethnic", "Gothic", "Darkwave", "Techno-Industrial", "Electronic", "Pop-Folk",
	"Eurodance", "Dream", "Southern Rock", "Comedy", "Cult", "Gangsta",
	"Top 40", "Christian Rap", "Pop/Funk", "Jungle", "Native American", "Cabaret",
	"New Wave", "Psychadelic", "Rave", "Showtunes", "Trailer", "Lo-Fi",
	"Tribal", "Acid Punk", "Acid Jazz", "Polka", "Retro", "Musical",
	"Rock & Roll", "Hard Rock", "Folk", "Folk/Rock", "National Folk", "Swing",
	"Fast-Fusion", "Bebob", "Latin", "Revival", "Celtic", "Bluegrass", "Avantgarde",
	"Gothic Rock", "Progressive Rock", "Psychedelic Rock", "Symphonic Rock", "Slow Rock", "Big Band",
	"Chorus", "Easy Listening", "Acoustic", "Humour", "Speech", "Chanson",
	"Opera", "Chamber Music", "Sonata", "Symphony", "Booty Bass", "Primus",
	"Porn Groove", "Satire", "Slow Jam", "Club", "Tango", "Samba",
	"Folklore", "Ballad", "Power Ballad", "Rhythmic Soul", "Freestyle", "Duet",
	"Punk Rock", "Drum Solo", "A capella", "Euro-House", "Dance Hall",
	"Goa", "Drum & Bass", "Club House", "Hardcore", "Terror",
	"Indie", "BritPop", "NegerPunk", "Polsk Punk", "Beat",
	"Christian Gangsta", "Heavy Metal", "Black Metal", "Crossover", "Contemporary C",
	"Christian Rock", "Merengue", "Salsa", "Thrash Metal", "Anime", "JPop",
	"SynthPop",
};

typedef struct id3tag {
	unsigned char tag[3];
	unsigned char title[30];
	unsigned char artist[30];
	unsigned char album[30];
	unsigned char year[4];
	unsigned char comment[30];
	unsigned char genre;
} id3tag;

/* structure to receive extracted header */
/* toc may be NULL*/
typedef struct
{
  char		alert;
  char		*tagId;
  int		tagStartsAt;
  int		tagEndsAt;		/* I need to know where the tag actually ends */
  int		frameSize;		/* I want to keep the size of the frame containing the tag */
#define TAG_NOTAG      0
#define TAG_VBRITAG    1
#define TAG_XINGTAG    2
#define TAG_LAMECBRTAG 3
  char		infoTag;
  short		version;
  float		delay;
  short		tocEntries;
//  short		scale4TocEntries;
  short		sizePerTocEntry;
  short		framesPerTocEntry;      /* not much clear... */
  int		tocSize;
  int		frames;			/* total bit stream frames from Vbr header data */
  int		bytes;			/* total bit stream bytes from Vbr header data*/
  int		vbr_scale;		/* encoded vbr scale from Vbr header data*/
  char		lametag[LAMETAGSIZE];
} VBRTAGDATA;

typedef struct detectionInfo {
  int		blockCount[3];
  int		modeCount[5];
  char		usesScfsi;         /* this must be set to 0 */
  char		usesScalefacScale; /* this must be set to 0 */
  char		usesPadding;       /* this must be set to 0 */
} detectionInfo;

typedef struct frameCounterCell {
  int		frameSize;
  int		frameCount;
} frameCounterCell;

typedef struct streamInfo {
  unsigned char	id;
  unsigned char	lay;
  int		filesize;
  int		totFrameLen;  /* this must be set to 0 */
  int		totFrameNum;  /* this must be set to 0 */
  unsigned char	lsf;
  int		freq;
  char		mode;
  char		crc;
  char		copyright;
  char		original;
  char		emphasis;
  int		reservoirMax; /* this must be set to 0 */
  char		freeformat;   /* this must be set to 0 */
  int		bitrateCount[15];
  frameCounterCell	unpadded[15];
  frameCounterCell	padded[15];
  int		nSyncError;
} streamInfo;

char GetInfoTag(VBRTAGDATA *pTagData, char *buf, int b2r, int br, int pos);

//int SeekPoint(unsigned char TOC[NUMTOCENTRIES], int file_bytes, float percent);
//int InitVbrTag(lame_global_flags *gfp);
//int PutVbrTag(lame_global_flags *gfp,FILE *fid,int nVbrScale);
//void AddVbrFrame(lame_global_flags *gfp);


#endif
